<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>com.demo.operations</groupId>
    <artifactId>incident-reporter</artifactId>
    <version>1.0-SNAPSHOT</version>

    <repositories>
        <repository>
            <id>axual-artifacts</id>
            <name>Axual Artifacts</name>
            <url>https://dev.axual.io/nexus/repository/axual-artifacts/</url>
        </repository>
    </repositories>

    <properties>
        <apache.avro.version>1.8.2</apache.avro.version>
        <spring.version>1.5.3.RELEASE</spring.version>
        <axual.client.version>5.4.4</axual.client.version>
        <slf4j.version>1.7.25</slf4j.version>
        <java.version>11</java.version>
    </properties>

    <dependencies>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-validation</artifactId>
            <version>${spring.version}</version>
        </dependency>
        <dependency>
            <groupId>io.axual.client</groupId>
            <artifactId>axual-client</artifactId>
            <version>${axual.client.version}</version>
        </dependency>
        <dependency>
            <groupId>org.apache.avro</groupId>
            <artifactId>avro</artifactId>
            <version>${apache.avro.version}</version>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-configuration-processor</artifactId>
            <optional>true</optional>
        </dependency>
    </dependencies>

    <build>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.8.1</version>
                <configuration>
                    <release>${java.version}</release>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.avro</groupId>
                <artifactId>avro-maven-plugin</artifactId>
                <version>${apache.avro.version}</version>
                <executions>
                    <execution>
                        <phase>generate-sources</phase>
                        <goals>
                            <goal>schema</goal>
                        </goals>
                        <configuration>
                            <sourceDirectory>${project.basedir}/src/schemas</sourceDirectory>
                            <!--     The directory where Avro writes code-generated sources.-->
                            <outputDirectory>${project.build.directory}/generated-sources/avro
                            </outputDirectory>
                            <imports>
                                <import>${project.basedir}/src/schemas/general/Application.avsc
                                </import>
                                <import>${project.basedir}/src/schemas/general/Severity.avsc
                                </import>
                            </imports>
                            <stringType>CharSequence</stringType>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-maven-plugin</artifactId>
                <version>${spring.version}</version>
                <configuration>
                    <mainClass>com.demo.operations.IncidentReporterCommandLineRunner</mainClass>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>2.22.0</version>
                <configuration>
                    <argLine>
                        --illegal-access=permit
                    </argLine>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-failsafe-plugin</artifactId>
                <version>2.22.0</version>
                <configuration>
                    <argLine>
                        --illegal-access=permit
                    </argLine>
                </configuration>
            </plugin>
        </plugins>
        <resources>
            <resource>
                <directory>src/main/resources</directory>
            </resource>
        </resources>
    </build>

</project>